<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAncillaryCatalogueItemType ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfAncillaryCatalogueItemType extends AbstractStructArrayBase
{
    /**
     * The AncillaryCatalogueItemType
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgAncillaryCatalogueItemType[]
     */
    public $AncillaryCatalogueItemType;
    /**
     * Constructor method for ArrayOfAncillaryCatalogueItemType
     * @uses DgArrayOfAncillaryCatalogueItemType::setAncillaryCatalogueItemType()
     * @param \dgsoft\StructType\DgAncillaryCatalogueItemType[] $ancillaryCatalogueItemType
     */
    public function __construct(array $ancillaryCatalogueItemType = array())
    {
        $this
            ->setAncillaryCatalogueItemType($ancillaryCatalogueItemType);
    }
    /**
     * Get AncillaryCatalogueItemType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgAncillaryCatalogueItemType[]|null
     */
    public function getAncillaryCatalogueItemType()
    {
        return isset($this->AncillaryCatalogueItemType) ? $this->AncillaryCatalogueItemType : null;
    }
    /**
     * Set AncillaryCatalogueItemType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgAncillaryCatalogueItemType[] $ancillaryCatalogueItemType
     * @return \dgsoft\ArrayType\DgArrayOfAncillaryCatalogueItemType
     */
    public function setAncillaryCatalogueItemType(array $ancillaryCatalogueItemType = array())
    {
        foreach ($ancillaryCatalogueItemType as $arrayOfAncillaryCatalogueItemTypeAncillaryCatalogueItemTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfAncillaryCatalogueItemTypeAncillaryCatalogueItemTypeItem instanceof \dgsoft\StructType\DgAncillaryCatalogueItemType) {
                throw new \InvalidArgumentException(sprintf('The AncillaryCatalogueItemType property can only contain items of \dgsoft\StructType\DgAncillaryCatalogueItemType, "%s" given', is_object($arrayOfAncillaryCatalogueItemTypeAncillaryCatalogueItemTypeItem) ? get_class($arrayOfAncillaryCatalogueItemTypeAncillaryCatalogueItemTypeItem) : gettype($arrayOfAncillaryCatalogueItemTypeAncillaryCatalogueItemTypeItem)), __LINE__);
            }
        }
        if (is_null($ancillaryCatalogueItemType) || (is_array($ancillaryCatalogueItemType) && empty($ancillaryCatalogueItemType))) {
            unset($this->AncillaryCatalogueItemType);
        } else {
            $this->AncillaryCatalogueItemType = $ancillaryCatalogueItemType;
        }
        return $this;
    }
    /**
     * Add item to AncillaryCatalogueItemType value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgAncillaryCatalogueItemType $item
     * @return \dgsoft\ArrayType\DgArrayOfAncillaryCatalogueItemType
     */
    public function addToAncillaryCatalogueItemType(\dgsoft\StructType\DgAncillaryCatalogueItemType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgAncillaryCatalogueItemType) {
            throw new \InvalidArgumentException(sprintf('The AncillaryCatalogueItemType property can only contain items of \dgsoft\StructType\DgAncillaryCatalogueItemType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AncillaryCatalogueItemType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgAncillaryCatalogueItemType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgAncillaryCatalogueItemType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgAncillaryCatalogueItemType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgAncillaryCatalogueItemType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgAncillaryCatalogueItemType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AncillaryCatalogueItemType
     */
    public function getAttributeName()
    {
        return 'AncillaryCatalogueItemType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfAncillaryCatalogueItemType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
